
//+------------------------------------------------------------------+
//|                                         Brooky_WPR_Sentiment.mq4 |
//|                                          Copyright  2010,Brooky |
//|                               http://forex-indicators.weebly.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010,Brooky"
#property link      "http://forex-indicators.weebly.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 C'67,67,67'
#property indicator_color2 Red
#property indicator_color3 Orange
#property indicator_color4 Green


#property indicator_maximum 0
#property indicator_minimum -100 

#property indicator_width1 2
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1


#property indicator_level1 -60
#property indicator_level2 -40
#property indicator_level3 0
#property indicator_levelcolor C'54,54,54'

//---- input parameters
extern int       WPR_Period=2000;
extern int       Sig_Ma = 500;
extern int       Sig_Smooth = 5;


//---- buffers
double WPR_Raw[];
double WPR_Adjusted[];
double Adjuster[];
double AdjusterRaw[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(4);
   
   SetIndexStyle(0,DRAW_LINE);SetIndexBuffer(0,WPR_Raw);SetIndexLabel(0,"WPR ("+WPR_Period);
   
   SetIndexStyle(1,DRAW_LINE);SetIndexBuffer(1,WPR_Adjusted);SetIndexLabel(1,"Dynamic Smooth ("+Sig_Smooth);

   SetIndexBuffer(2,Adjuster);
   
   SetIndexBuffer(3,AdjusterRaw);
   
   

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   Comment("");
  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
  int start()
    {
     int limit,i;
     int counted_bars=IndicatorCounted();
  //---- check for possible errors
     if(counted_bars<0) return(-1);
  //---- the last counted bar will be recounted
     if(counted_bars>0) counted_bars--;
     limit=Bars-counted_bars;
     double candle_open,candle_close;
  
  
 int CalcBars=WPR_Period;
 if(Bars-1 < CalcBars) return(0);
 if(counted_bars < 0) return(-1);
 if(counted_bars > 0) counted_bars--;
 CalcBars = Bars - 1 - WPR_Period;
 limit = (Bars - 1 - counted_bars);
  if(limit > CalcBars){
  for(i = Bars - 1; i >= CalcBars; i--) {
   Adjuster[i] = 0.0;
   WPR_Adjusted[i] = 0.0;
   WPR_Raw[i] = 0.0;
   AdjusterRaw[i] = 0.0;
   
  }
  limit = CalcBars; 
 }
  //---- main loop
 for(i = limit;i >= 0; i--)
 {
      Adjuster[i]=(iBWMFI(NULL, 0, i)+(MathSqrt(Volume[i])))/2;   
        if(i==Bars-1)
         {
         Adjuster[i]=(iBWMFI(NULL, 0, i)+(MathSqrt(Volume[i])))/2;
         }
          else
          {
          candle_open=Close[i+1];
          candle_close=Close[i];
          }
         if(candle_close==candle_open)
         {
         Adjuster[i]=Adjuster[i+1];
         }
          else
          if(candle_close<candle_open)
          {
          Adjuster[i]=Adjuster[i+1]-((iBWMFI(NULL, 0, i)+(MathSqrt(Volume[i])))/2);
          }
         
          else Adjuster[i]=Adjuster[i+1]+((iBWMFI(NULL, 0, i)+(MathSqrt(Volume[i])))/2);
          
          
         }
 for(i = limit; i >= 0; i--)
          {
      
      //--Standard WPR--+
          double highestval=High[iHighest(NULL,0,MODE_HIGH,WPR_Period,i)];
          double lowesttval=Low[iLowest(NULL,0,MODE_LOW,WPR_Period,i)];
          double closeval=Close[i+1];
          double wrperc = (highestval-closeval)/(highestval-lowesttval)*(-100);
          WPR_Raw[i]=wrperc;
         }
      //--Adjusted WPR--+
 for(i = limit; i >= 0;i--)
         {
        double highestval_adj  =Adjuster[ArrayMaximum(Adjuster,Sig_Ma,i)];
        double lowesttval_adj  = Adjuster[ArrayMinimum(Adjuster,Sig_Ma,i)];
        double val_now = Adjuster[i];
        AdjusterRaw[i] = (highestval_adj- val_now )/(highestval_adj- lowesttval_adj)*(-100);
        
        }

 for(i = limit; i >= 0; i--)
       {
      
         WPR_Adjusted[i] = iMAOnArray(AdjusterRaw,0,Sig_Smooth,0,MODE_LWMA,i);
         
       }

       
  //---- done
     return(0);
    }
    

//+------------------------------------------------------------------+

